Percona Server with XtraDB

Crash when query_cache_strip_comments enabled

Reported by Arnaud on 2011-09-22
16
This bug affects 3 people
Affects Status Importance Assigned to Milestone
Percona Server
High
Alexey Kopytov
5.1
High
Unassigned
5.5
High
Alexey Kopytov

Bug Description

Hello,

This query makes our Percona servers (5.5.11 and 5.5.15) crash when query_cache_strip_comments is enabled :

Query (0x337e880): SELECT s.lid, t.translation, s.version FROM locales_source s LEFT JOIN locales_target t ON s.lid = t.lid AND t
.language = 'fr' WHERE s.source = 'If you need to translate Views labels into other languages, consider installing the <a href=\"
!path\">Internationalization</a> package\'s Views translation module.' AND s.context = '' AND s.textgroup = 'default'

The trace:

*** glibc detected *** ./mysqld: malloc(): memory corruption: 0x00000000020f8560 ***
======= Backtrace: =========
/lib/libc.so.6(+0x775b6)[0x7f2e772565b6]
/lib/libc.so.6(+0x7b6d8)[0x7f2e7725a6d8]
/lib/libc.so.6(__libc_malloc+0x6e)[0x7f2e7725b58e]
./mysqld(my_malloc+0x32)[0x7ca472]
./mysqld(alloc_root+0x7e)[0x7c4dce]
./mysqld(_Z10MYSQLparsePv+0x13bab)[0x659e9b]
./mysqld(_Z9parse_sqlP3THDP12Parser_stateP19Object_creation_ctx+0x9d)[0x57183d]
./mysqld(_Z11mysql_parseP3THDPcjP12Parser_state+0x2c1)[0x57d621]
./mysqld(_Z16dispatch_command19enum_server_commandP3THDPcj+0x148e)[0x57eb9e]
./mysqld(_Z10do_commandP3THD+0x106)[0x57ef36]
./mysqld(_Z24do_handle_one_connectionP3THD+0x111)[0x619a81]
./mysqld(handle_one_connection+0x54)[0x619b74]
/lib/libpthread.so.0(+0x69ca)[0x7f2e780329ca]
/lib/libc.so.6(clone+0x6d)[0x7f2e772c570d]
======= Memory map: ========
00400000-00d4d000 r-xp 00000000 fc:05 155614 /opt/Percona-Server-5.5.15-rel21.0-158.Linux.x86_64/bin/mysqld
00f4c000-01068000 rw-p 0094c000 fc:05 155614 /opt/Percona-Server-5.5.15-rel21.0-158.Linux.x86_64/bin/mysqld
01068000-01095000 rw-p 00000000 00:00 0
014c0000-0313d000 rw-p 00000000 00:00 0 [heap]
7f2e5c000000-7f2e5c021000 rw-p 00000000 00:00 0
7f2e5c021000-7f2e60000000 ---p 00000000 00:00 0
7f2e61857000-7f2e61858000 ---p 00000000 00:00 0
7f2e61858000-7f2e62058000 rw-p 00000000 00:00 0
7f2e62058000-7f2e62059000 ---p 00000000 00:00 0
7f2e62059000-7f2e62859000 rw-p 00000000 00:00 0
7f2e62859000-7f2e6285a000 ---p 00000000 00:00 0
7f2e6285a000-7f2e6305a000 rw-p 00000000 00:00 0
7f2e6305a000-7f2e6305b000 ---p 00000000 00:00 0
7f2e6305b000-7f2e6385b000 rw-p 00000000 00:00 0
7f2e6385b000-7f2e6385c000 ---p 00000000 00:00 0
7f2e6385c000-7f2e6405c000 rw-p 00000000 00:00 0
7f2e6405c000-7f2e6405d000 ---p 00000000 00:00 0
7f2e6405d000-7f2e64aeb000 rw-p 00000000 00:00 0
7f2e64f09000-7f2e64f0a000 ---p 00000000 00:00 0
7f2e64f0a000-7f2e6570a000 rw-p 00000000 00:00 0
7f2e6570a000-7f2e6570b000 ---p 00000000 00:00 0
7f2e6570b000-7f2e65f0b000 rw-p 00000000 00:00 0
7f2e65f0b000-7f2e65f0c000 ---p 00000000 00:00 0
7f2e65f0c000-7f2e6670c000 rw-p 00000000 00:00 0
7f2e6670c000-7f2e6670d000 ---p 00000000 00:00 0
7f2e6670d000-7f2e66f0d000 rw-p 00000000 00:00 0
7f2e66f0d000-7f2e66f0e000 ---p 00000000 00:00 0
7f2e66f0e000-7f2e6770e000 rw-p 00000000 00:00 0
7f2e6770e000-7f2e6770f000 ---p 00000000 00:00 0
7f2e6770f000-7f2e67f0f000 rw-p 00000000 00:00 0
7f2e67f0f000-7f2e67f10000 ---p 00000000 00:00 0
7f2e67f10000-7f2e68710000 rw-p 00000000 00:00 0
7f2e68710000-7f2e68711000 ---p 00000000 00:00 0
7f2e68711000-7f2e68f11000 rw-p 00000000 00:00 0
7f2e68f11000-7f2e68f12000 ---p 00000000 00:00 0
7f2e68f12000-7f2e75f8c000 rw-p 00000000 00:00 0
7f2e75f8c000-7f2e75f98000 r-xp 00000000 fc:05 131850 /lib/libnss_files-2.11.1.so
7f2e75f98000-7f2e76197000 ---p 0000c000 fc:05 131850 /lib/libnss_files-2.11.1.so
7f2e76197000-7f2e76198000 r--p 0000b000 fc:05 131850 /lib/libnss_files-2.11.1.so
7f2e76198000-7f2e76199000 rw-p 0000c000 fc:05 131850 /lib/libnss_files-2.11.1.so
7f2e76199000-7f2e761a3000 r-xp 00000000 fc:05 131852 /lib/libnss_nis-2.11.1.so
7f2e761a3000-7f2e763a2000 ---p 0000a000 fc:05 131852 /lib/libnss_nis-2.11.1.so
7f2e763a2000-7f2e763a3000 r--p 00009000 fc:05 131852 /lib/libnss_nis-2.11.1.so
7f2e763a3000-7f2e763a4000 rw-p 0000a000 fc:05 131852 /lib/libnss_nis-2.11.1.so
7f2e763a4000-7f2e763bb000 r-xp 00000000 fc:05 131847 /lib/libnsl-2.11.1.so
7f2e763bb000-7f2e765ba000 ---p 00017000 fc:05 131847 /lib/libnsl-2.11.1.so
7f2e765ba000-7f2e765bb000 r--p 00016000 fc:05 131847 /lib/libnsl-2.11.1.so
7f2e765bb000-7f2e765bc000 rw-p 00017000 fc:05 131847 /lib/libnsl-2.11.1.so
7f2e765bc000-7f2e765be000 rw-p 00000000 00:00 0
7f2e765be000-7f2e765c6000 r-xp 00000000 fc:05 131848 /lib/libnss_compat-2.11.1.so
7f2e765c6000-7f2e767c5000 ---p 00008000 fc:05 131848 /lib/libnss_compat-2.11.1.so
7f2e767c5000-7f2e767c6000 r--p 00007000 fc:05 131848 /lib/libnss_compat-2.11.1.so
7f2e767c6000-7f2e767c7000 rw-p 00008000 fc:05 131848 /lib/libnss_compat-2.11.1.so
7f2e767c7000-7f2e767dd000 r-xp 00000000 fc:05 131757 /lib/libgcc_s.so.1
7f2e767dd000-7f2e769dc000 ---p 00016000 fc:05 131757 /lib/libgcc_s.so.1
7f2e769dc000-7f2e769dd000 r--p 00015000 fc:05 131757 /lib/libgcc_s.so.1
7f2e769dd000-7f2e769de000 rw-p 00016000 fc:05 131757 /lib/libgcc_s.so.1
7f2e769de000-7f2e769df000 ---p 00000000 00:00 0
7f2e769df000-7f2e771df000 rw-p 00000000 00:00 0
7f2e771df000-7f2e77359000 r-xp 00000000 fc:05 131840 /lib/libc-2.11.1.so
7f2e77359000-7f2e77558000 ---p 0017a000 fc:05 131840 /lib/libc-2.11.1.so
7f2e77558000-7f2e7755c000 r--p 00179000 fc:05 131840 /lib/libc-2.11.1.so
7f2e7755c000-7f2e7755d000 rw-p 0017d000 fc:05 131840 /lib/libc-2.11.1.so
7f2e7755d000-7f2e77562000 rw-p 00000000 00:00 0
7f2e77562000-7f2e77564000 r-xp 00000000 fc:05 131844 /lib/libdl-2.11.1.so
7f2e77564000-7f2e77764000 ---p 00002000 fc:05 131844 /lib/libdl-2.11.1.so
7f2e77764000-7f2e77765000 r--p 00002000 fc:05 131844 /lib/libdl-2.11.1.so
7f2e77765000-7f2e77766000 rw-p 00003000 fc:05 131844 /lib/libdl-2.11.1.so
7f2e77766000-7f2e7776f000 r-xp 00000000 fc:05 131843 /lib/libcrypt-2.11.1.so
7f2e7776f000-7f2e7796f000 ---p 00009000 fc:05 131843 /lib/libcrypt-2.11.1.so
7f2e7796f000-7f2e77970000 r--p 00009000 fc:05 131843 /lib/libcrypt-2.11.1.so
7f2e77970000-7f2e77971000 rw-p 0000a000 fc:05 131843 /lib/libcrypt-2.11.1.so
7f2e77971000-7f2e7799f000 rw-p 00000000 00:00 0
7f2e7799f000-7f2e779a6000 r-xp 00000000 fc:05 131960 /lib/librt-2.11.1.so
7f2e779a6000-7f2e77ba5000 ---p 00007000 fc:05 131960 /lib/librt-2.11.1.so
7f2e77ba5000-7f2e77ba6000 r--p 00006000 fc:05 131960 /lib/librt-2.11.1.so
7f2e77ba6000-7f2e77ba7000 rw-p 00007000 fc:05 131960 /lib/librt-2.11.1.so
7f2e77ba7000-7f2e77c29000 r-xp 00000000 fc:05 131845 /lib/libm-2.11.1.so

Even if I don't really understand why, disabling query_cache_strip_comments has stopped the crashes...

Related branches

lp:~tsarev/percona-server/5.5_fix_bug_856404
Merged into lp:percona-server/5.5 at revision 199
Stewart Smith (community): Approve on 2011-12-16
Laurynas Biveinis: Pending requested 2011-12-16
Alexey Kopytov: Pending requested 2011-12-16
Oleg Tsarev (tsarev) on 2011-09-22
Changed in percona-server:
assignee: nobody → Oleg Tsarev (tsarev)
importance: Undecided → High
Stewart Smith (stewart) wrote :

lp:~stewart/dbqp/query_cache_strip_comments

./dbqp.py --libeatmydata --default-server-type=mysql --basedir=/home/stewart/percona-server/5.5/Percona-Server --suite=randgen_basic query_cache_strip_comments_test

Changed in percona-server:
status: New → Triaged
Oleg Tsarev (tsarev) wrote :

Looks like to bug in dbqp. Please ask anything if you need.

oleg.tsarev (0) /storage/dev/percona/query_cache_strip_comments$ ./dbqp.py --libeatmydata --default-server-type=mysql --basedir=/storage/dev/percona/query_cache_strip_comments_source/Percona-Server-5.5.16-rel21.0-debug/ --suite=randgen_basic query_cache_strip_comments_test
20111031-160425 INFO Linking workdir /storage/dev/percona/query_cache_strip_comments/workdir to /dev/shm/dbqp_workdir_oleg.tsarev_63c851d2-12a7-459e-acac-bfbd5e877562
20111031-160425 ERROR Required file not found out of options: /storage/dev/percona/query_cache_strip_comments_source/Percona-Server-5.5.16-rel21.0-debug/mysql/charsets ,/storage/dev/percona/query_cache_strip_comments_source/Percona-Server-5.5.16-rel21.0-debug/sql/share/charsets ,/storage/dev/percona/query_cache_strip_comments_source/Percona-Server-5.5.16-rel21.0-debug/share/charsets

Changed in percona-server:
assignee: Oleg Tsarev (tsarev) → Patrick Crews (patrick-crews)
Patrick Crews (patrick-crews) wrote :

Need to do some work to handle out of source builds to find things nicely. Will have a patch for this asap

Oleg Tsarev (tsarev) on 2011-11-07
Changed in percona-server:
assignee: Patrick Crews (patrick-crews) → Oleg Tsarev (tsarev)
status: Triaged → In Progress
Oleg Tsarev (tsarev) on 2011-11-08
Changed in percona-server:
status: In Progress → Fix Committed
Dr. Tyrell (dr.tyrell) wrote :

Has this been committed to 5.1 series. We have 5.1.59 x86_64
We had query_cache_strip_comments=ON and have been getting the same error.
I have now turned it off based on this thread.

Thanks.

Oleg Tsarev (tsarev) wrote :

Dr. Turell,

Thank you for your feedback. I have a fix, after merge to 5.5 will port fix to 5.1.

Regards, Oleg

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers